﻿using Evcb.Service.Service.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OCPPServer.Common
{
    public class OCPPResult : IResult
    {
        public Guid ID
        {
            get;
            private set;
        }

        public bool Success
        {
            get;
            set;
        }

        public string Message
        {
            get;
            set;
        }

        public Exception Exception
        {
            get;
            set;
        }

        public List<IResult> InnerResults
        {
            get;
            protected set;
        }

        public object Payload
        {
            get;
            set;
        }

        public OCPPResult()
            : this(false)
        {
        }

        public OCPPResult(bool success)
        {
            ID = Guid.NewGuid();
            Success = success;
            InnerResults = new List<IResult>();
        }

    }
}
